  This list is more for the use of the programmer than any thing else but might
  prove useful to users.

  Changelog created from the Changes lists in Flightlog program sources
  where the latest is last in this list: Note 'e' after version # is guessed.
  This includes ALL changes to the source including bug fixes, etc, found while
  testing as well as feature additions since the start of programming including
  versions for IBM & ICL m/f's and yes there is a lot. That is what happens
  during testing :)

  Note that many feature changes can themselves be changed further down in this
  Changelog.

  First two digits in version number represent the major and minor number where
  minor changes within a major version.
  The third number is the build number and is incremented by 1 for each change
  done at the same time.

  When reporting bugs please always specify the full version of the Flightlog
  program as displayed or printed.

  Data compatibility between versions will, where ever possible, always be the
  same but if a change HAS to be made, a data conversion program will be
  supplied with a name starting with 'xxxxconv' and this will need to be
  built / compiled in the same way that flightlog is.
  (if changing the O/S version say Windows to Linux) then run, prior to running
  the latest Flightlog version having saved your data files to a 'back up'
  directory in case of a problem and this is vital that you do so before using
  such programs.

??/??/76 vbc - 0.nn    Original written in Basic.
??/??/8? vbc - 0.nn    Rewritten in Cobol for m/f and msdos.
17/11/86 VBC - 1.00    PROG CREATION for MF workbench v3 - OS/2, Windows &
                       Cromix.
18/01/87 VBC - 1.01e   SHORT PRINT
21/04/87 VBC - 1.02e   TIDY UP PROG.
22/05/87 VBC - 1.03e   SUPPORT FOR 'NEXT' IN AMEND/DELETE LOGBOOK.
07/06/88 vbc - 1.04e   Changes to run on cobol2 (MF workbench) removing CICS.
02/12/89 vbc - 1.20e   Support for escape, function keys, see airfields on
                       log book data entry and see Aircraft & other tidy ups.

08/09/18 vbc - 1.26    Migration to the GnuCOBOL compiler and sources converted
                       to Free format. This is free to use & download compiler.
                       Start to use Screen Section for data entry / display etc,
                       but may well be scrapped subject to program logic.

                       Increased Aircraft table size to 1000, i.e., double
                       previous and Airfield table size to 2000, i.e., double
                       previous. Will cover the most ambitious pilot.

                       Clean up and remove all tab chars in source code as kate
                       doesn't or any other editors tried.
                       FILE Layouts may well need changing / cleaning up.
                       This version will only support one pilot but another
                       version will cater for many working within a
                       organisation where time recording is processed to comply
                       with CAA, FAA (or other countries government aviation
                       departments) regulations.
                   .02 Change log book entries to with update, time input
                       using WSF so far. more needed.
                   .05 Added Sort of Aircraft file after writing file from
                       Aircraft table. Airfield file is ISAM so already done.
                       If sort fails then new deleted and backup file renamed
                       back to main file. At least the Anal. report will look
                       cleaner.

11/09/18 vbc - 1.26.06 Clean up anal heads and other stuff I have forgotten
                       Change format for all COMP fields in log file to display
                       as space saved is minor but will help in future data
                       migration if needed.

13/09/18 vbc - 1.27.01 On error during sorts and file rebuild, restore original
                       data file by copying *.bak to *.dat. See note for
                       build .05.
                   .02 Change top menu order with Enter log book as A and
                       Airfield data Edit as B as it is a sundry option.
                       Keeps in line with the second Log book menu anyway.
                   .03 Change comp for instrument time as wrong.
                   .04 In CD020-AMEND-LOGBK-DISPLAY change lit starting
                       Entry sequ to use line 6 as gets overwritten with
                       Single/Twin etc.
                   .05 On afld From take last TO as a starter if not spaces.
                   .06 Increased size of reg to 6, remarks to 32 JIC (Just in
                       Case),
                       changed analysis for more space for P1 / P2 night, added
                       Multi and 'Inst' and this was not coded let alone
                       correctly.
                       Must remember to change the LATEST sources - assuming I
                       could have found it.
                   .07 Removed coding for reports when 1st 2 digits of AC-Reg is
                       numeric as now REG is 6 chars.
                       NOTE for commercial flights use A/C reg NOT a flight
                       number as by regs it should always be the A/CFT & flt
                       no's change and will not match up and will be almost
                       impossible to verify.
                   .08 Print head lits not right for data.
                   .10 Prog name in reports and more head clean ups.
                   .12 Only using 1st 5 digits of AC-REG but for Nth American
                       A/C ignore the 'N' as it is inserted for printing.
                   .13 initialise WST-AIRCRAFT-TABLE in fix up routine and
                       else were.
                   .14 Bad fix for .13 wrong to do 01 table, Der.
                   .15 Added reporting of Airfields with ICAO codes after flight
                       times and before Aircraft analysis. Removes currently
                       TODO as doing it within report is too wide for any paper
                       width even using 160cc continuous stationery.
                       Use full date for report heads in all cases (dd/mm/ccyy).
                       Moved ws-user to a 77 level from within space-38 as looks
                       wrong when using spaces-38. Changed A B C Error-code from
                       3 to 4 digits JIC.
                   .16 Bug in above report airfields.
                   .18 With acft anal after airfield reporting doing
                       CCA040-LBR-Subs thru CCA050 not needed as done before
                       airfield.
                   .19 Moved all open and close Print-File to start menu so
                       just then one set of reporting that means that running a
                       Airfield list then doing the same for logbook will all
                       go to the same file/report.
                       Consider adding report option to use airfield names in
                       place of ICAO codes but will increase width of reports -
                       160+ col paper any one?
                       Now producing a listing of airfields near end of report
                       instead.  This is now done as hidden options 3 & 4
                       that can replace use of C & D in v2.02.

               1.27.20 Updated the copyright notices

               1.28.00 Increased version number to 1.28 and resetting build
                       number to 0.

                   .01 Set COB_EXIT_WAIT false to stop the End of Program msg.

                   .02 Moved error messages etc to literals with SY of FL
                       prefixes. A few left as may well cause confusion, when
                       reading code.
                       Removed the option of creating data files as now
                       automatically done if not exist in current directory.
               1.29.00 Changed log file date to ccyy from yy so all data entry
                       amend routines changed including position on screen of
                       data.
                       NEED TO DO FULL TESTING FOR THIS ONE in case of mistakes.
                       Although now fully supporting pre 2000 dates it may be
                       some what clunky in data entry - testing will show,
                       other wise revert back to yy entry and append to file
                       the century depending if yy > 69 then cc from current
                       year - 1 other wise current century in today's date.
                   .01 On reporting dates to/from not using cc.
                       Date in log reports now 2 over so move literal TYPE
                       over 1 over a space. Same with PR1 date & a/c type.
                   .02 CCD000-Airfield-Lists now used for both airfield reports
                       so BA000-LIST-AFLD can be removed (subject to testing) -
                       Done.
                       Added get User/Pilot name lic no. at both menus but left
                       in where existing code also request it if WS-User =
                       spaces.
                   .03 Changed aircraft/field menu order D & X wrong way round.
                   .04 Stopped reporting on Airfields for options F & G
                       Both menus accept character as auto (without return key).
                       On date check if space exit with error-code = 1
                       as reduces cpu cycles.
                   .05 Added option of Start time in logbook reports so that new
                       flights can be filled after last prior report saving paper.
                   .06 Changes to load airfield code and its caller.
                   .08 Updated to support swapout of screen data when F1 & F3
                       is pressed.
                       Update logbk Entry code to support Amend and therefore
                       removing the original amend code - reduces proc div
                       code. I hope.
                   .09 Chgd D000-Setup-Datafiles to only be processed in
                       A000-Control  as was previously also in C000-EDIT-LOG-BOOK.
                       Cleaned up ZZA-Status tests removing the 'thru xyz' paras.
                   .10 1st IF has comma not period in CA120-ENTER-LOGBK-START
                       caused hard loop.
                   .11 Also missing DIVIDE statement in above para.
                   .12 In para proc for From only copy to FLT-To if Entry not Amend.
                   .13 Open i/o airfield missing at start-ish of menu.
                   .14 init flightlog-record for entry amend logbk, remove
                       ws-spaces-nn for erase eol.
                   .15 With funny chars on logbk entry for Ac reg and captain force
                       spaces at start of section after initialise.
                   .16 In logbk Entery make all escape captures goto CA030 and not
                       CA039 if Amend.
                   .17  display, Added chk for Analysis-Only-Flag set for options E F.
                   .18 On data entry for date at CA030-ENTER-LOGBK-DATE on subsequent
                       data entry u-date is spaces rebuild from FLT-Date if not zero.

27/09/18 vbc -     .19 At end of logbk entry go to CA30 not CA20.
                       Chg rec totals from flightlog file sort with clean up.
                   .20 Test for date when Deleting Option C as well as amend Option B
                       also accept F4 as well as zeros for (DD & MM & YY) and do NOT
                       test for the date delimiters
                       NOTE that both Amend or Delete will allow for zero date or F4.
                   .21 Data entry screen cleanup for prompts (F1, F3 etc) did not clear scr.
                   .22 Now using ws-21-Lines, 22, 23 amd ws-Lines in place of 21,22,23,24
                       other hoping to display last three data entry record betweeb date
                       and End time any way.
                   .23 Make accept 'reporting' user details a perform para.
                   .24 Remove uppercase move for TO airfield. Afld disp, mov accept +6.
                   .25 Period inside F4 test in CA039-AMEND-LOGBK-DATE breaks new date
                       testing during amend.
                   .26 removed test for analysis-only-flag in CCC020-LBR-HH-HEADS.

30/09/18 vbc -     .27 On Amend logbk if date or time changed do REWRITE as sometimes
                       not done. Removed dead (not called) first para in sections.
                       From TODO added WST-AC-Last-Reg to record last ac reg for that type
                       so that Reg can be prefilled if non space.
                       Run sort acft file after saving table at all times should remove
                       or at least reduce need to run Fixup often. Consider doing one for
                       airfields?
                   .28 Aircraft Fixup adds A/C reg to table so LAST reg for type is
                       now held in the Aircraft table and in file.
                       Type will be initialy displayed for new entry for same a/c type.
                       Reduced spacing in logbook reports to get captain all in and help
                       to get printed most/all of remarks. Heads also changed.
                   .29 Forgot to add in a/c reg in acft table if type present.
                       more tidying up of report headings and field positioning.
                       for acft reg allow for USA regs without init 'N'.
                   .30 Adjust selection for a/c anal (option D) and restore option G
                       table size report.
01/10/18 vbc -     .31 FL020 added to support extra Q for 'M'ulti or 'S'ingle
                       after entering new A/C type along with msg FL021.
                       Added field WS-Elapsed-HHMM to compute estimated Pn time
                       in logbk entry but a bit of a guess. Added FL022 for
                       time compute problems after entry of P1, P2/3 & IFR.

01/10/18 vbc - 1.30.00 Updated version as lots of changes.
                       Amend logbook merged into Logbook entry code - saves 800+ lines
                       of source code.
                   .01 Start of WS for calculating Night time by month and in anything
                       event is a rough guide based from the shortest and longest day
                       with time moving 1 hour per month with Dec shortest at 15:30
                       and June Longest at 21:30. Where all recording start/end times
                       in GMT.
                   .02 Time-Remaining should be used not -HHMM for if zero test in
                       Night P1 or P23 data entries.
                   .03 Remarks ']' 12 more right to pos. 92. screen width must be =>92
                       so SY011 msg changed.
                   .04 period before goto in IRS test.
                   .05 Start coding for Cert of Exp report with log recs read in reverse
                       using table WS4-Analysis print out in order LAST (days from today)
                       30, 91, 182, 395 (13 months) in all headings of P1,P2, P3 day and night
                       IFR flight, Multi, Single, Instructing. Table totals only so far.
                   .06 Added coding for night time calcs (.01) applies to Start time only.
                   .07 reset display times for all four in -CAP.
                   .08 Adjustment to SAVE-FLT-Date and start test in -Remarks
                       as it is selecting a sort and shouldn't.
                   .09 Removed bug causing blank first page for all logbook reports.
                       More coding (30.05) for a Cert of Exp report page by reading
                       logfile backwards from requested end date with Today being
                       default.
                       Adding date last flown for A/C types and Complex flag
                       for singles - All Multi's are complex and are so set.
                       Deleted TODO 4. for this feature.

05/10/18 vbc - 1.30.10 CoE coding complete - ready for testing. extra fields Complex
                       and last flight date still needs adding to Aircraft data file
                       and this will also need a change to the Aircraft amend code.
                       Likewise for logbk data entry needs addition data entry for
                       # landings (and in record)
                       Logbook record now has FLT-Ldgs for day, night flying plus 3 bytes
                       possible expansion at end.  STILL NEED TO ADD Landings to data entry.
                       Also logbook rec layout changed with Date, Start & End time together
                       one after other for when file becomes ISAM. Save worrying about ISAM
                       drivers working with split keys (Date & Start time).
                   .11 Removed the reporting of # landings looks messy and some what
                       pointless but keeping count of flights for CoE but that is not
                       producing any values so 1 or more bugs here.
                   .12 Still changing print layouts.
                   .13 In ca036-amend-logbk-get-record wrong move using 999999 as should
                       now be 99999999 after date size change.
                   .14 adjust data entry for ldgs to use a pic 9 field as FLT uses 99
                        as only space for 1 char.
                   .15 Data display for Amend needed adjusting.
                   .16 CoE coding will not work as is as REVERSED is not implemented.
                       so need to run a sort DESCENDING on date,start to a temp file
                       (.bak) and read that. Temp file deleted after use.
                       Change Landings default to zero from 1 as every Takeoff must
                       result in a landing so count will be only for T & G's and it
                       is only for CoE any way and otherwise not reported on.
                       Move CoE print group to the reporting file area.
                       FOR TESTING DO NOT DELETE BACKUP file. <<<<<<<<<<<-----
                   .17 More fixed for CoE as reporting info wrong.
                   .21 During CoE file processing read file into main file area.
                   .23 minor print o/p changes for CoE - still need to remove the test
                       data reporting per line.
                   .24 Removed test data reporting for CoE. Moved sub tots 1 over.
                   .25 Removed all the coding for processing # landings - it was only
                       going to be for CoE and entering it just makes data entry
                       clunky and for CoE, it is pointless from a log book point
                       of view.  WILL REMOVE THE FIELDS in the logbook file via a
                       conv program in a few days and might well convert it/all to ISAM.
                       AT this point might also be use full to remove the airfield and
                        Aircraft tables and make all search/insert/amend only work
                         with the relevant file/s- See TODO (1).
                   .26 Bug in Pn times in amend processing.
                   .27 Find where bad sort-flag is set looking a msg FL001 /FL001B.
                   .28 Hopefully now found (CA230).
                   .29 Hopefully clean up bugs/s on day night flight times.
                       Added new function in menu for changing an airfield ICAO
                       code for when wrong one used it it has been replaced.
                       This changes both the airfield record and all flightlog
                       records that also have the old one present in FROM or TO.
                       WHY? Airfield codes do get changed sometimes just when the
                       country changes its name.
                       Getting very close to changing all files to use ISAM and
                       discontinuing using tables for Aircraft and airfields.
                       Also might be a good time to add a new field to the Airfield
                       file for date last used and poss # of trips in/out of as
                       these useful for commercial pilots and Route renewals etc.
                   .30 Move code for afld change (.29) near end if case of errrors
                       processing flightlog file records.
                   .31 Use flightlogbackup with flightlog and sort at end force
                       processing aitfield change option- Messy but until ISAM...

13/10/18 vbc - 1.31.00 Convert all files over to ISAM, remove need for Acft and
                       Afld tables but use search or update the file record
                       instead by updating the performed routines in Zxx to used
                       file processing. SY msgs changed and test for wrong rec
                       sizes. Chg name to 1st acft rec field.

16/10/18 vbc           Open all files at top menu ONLY and likewise close them
                       removing code doing same elsewhere.
                       Using the airfield and acft tables for statistical reporting.
                       Update file records for each at end for dates & flights.

18/10/18 vbc           Renumbering FL error/warning mesages to omit unused ones.
                       With files moving to ISAM, all sort code removed.
                       Backup files now used to create Sequential version of the ISAM
                       files in case change of compiler / platform / ISAM driver etc.
                       REMEMBER TO ADD IN DOCS about this function.
                       File defs done for csv flight data import file as received from
                       airline.  NORMALLY FOR COMMERCIAL PILOTS ONLY.
                       Removed unused messages and WS fields that are not required.

19/10/18 vbc - 1.31.01 Fixed bug/s as afld and acft tables not loaded for reporting.
                       Added extra afld fields last-flt & cnt for aflds for reporting
                       and last flight for acft.
                   .02 Bug in afld rep layout and reduce to 3 per line use table not
                       file/both etc with both code errors.
                   .03 Nite Ins subs wrong - might need more looking only found one prob.
                       No last flight date for A/C.
                   .04 A/C repos for date.
                   .05 Repo move for month test for B/C fwd sub totals.
                   .06 Not getting space in airfields on chg of 1st 2 letters.
                   .07 For airfields was testing for Z & USA is K.

 19/10/18 vbc - 1.32.00 Added new option Change Aircraft type for all log book entries and
                        the Aircraft file. Yes I did, PA28-235 should be PA28-236.

 20/10/18 vbc       .02 Junk in headings for airfields? moving to wrong print area.
                    .03 Still junk at 3rd line airfield listings use Print-Report area.
                        Blasted thing worked before changes - nuts also changes to days
                        and nite P? data going a bit screw wiff - not back to previous Pn
                        so check for F10 and ignore if test for nite.
                        Found - Bad record in airfield file.
                    .04 Added features - if Z or z entered char 1 for time on P!/P23 days
                        or nite make zeros, ALSO if escaped from P1/23 IFR don't do nite test.
                    .05 Bug when rewrite and delete amended (date-time) flightlog rec.

 21/10/18           .06 When updated aircraft and airfield could be writing junk data in
                        Remarks processing as using wrong field for key (ws- ICAO-CODE)
                        This hopefully will get rid of possibly creating bad data in both
                        files (.03).  Removed the temp code in afld anal to check for junk
                        data.
                    .07 Menu option H overwritten so is missing.
                    .08 IF within 'IF' not working on SW-Escape tests compiler!!, so changed.
                    .09 If 'I' entered for capacity equals P1I - feeling lazy, less typing
                        and entering 'S ' produces SELF for Pilot name.
                    .10 More base coding for file lay outs for CDF data importing but no
                        coding for processing such yet.
                        On log book data entry check date/time rec does NOT exist after
                        entry of start time - key is Date/start time. Not in Amend mode.

 22/10/18           .11 On list afld load the table.
                    .12 Ensure airfield last flt data is saved after reports C D etc.
                    .13 Remove F2 after date and start time as some WS fields not setup
                        and not really needed - This is in Amend mode only.
                        Remove F4 from prompt after start time proc as no longer needed
                        in later processing.
                        Added F5 - Save in Amend mode from late point in CAPACITY entry
                        after displays of Pn times, to jump to saving data records, saves
                        some entry time.
                        Reset prompt5 to 5B etc at the correct point for above and moved
                        prompt displays from CA020 menu to CA030 Date data entry.
                    .14 Don't init. flightlog rec at start of data entry so that last
                        rec date can be used - got to be better than today's date.
                    .15 Don't init. same else were so lastest can be used at start.
                    .16 Early code to support other formats of date input & output.
                        See TODO #5.
                        Created new CDF rec def for date/time layouts. Still no code
                        though - to do. Could use LC_TIME for this but will it match the
                        CDF rec ??
                        Additional notes regarding COBOL compiler functions used listed
                        below Remarks in section above here.
                    .17 display zeros on accepting a Z/z for time for P1 or P23.
                    .18 Getting junk for airfield so code to chk for non alphabetics.
                    .19 Extra code checking for alphabetic chars for Airfield fields
                        before accepting or updating airfield file. When accept new
                        airfield in additions of check for space also check for ESC
                        and F10 and return to Accept data again.
                        Start of coding for CDF processing. See TODO (3).
                    .20 Added to Capacity values P1T treat same as P1I also accept
                        'T' as well as 'I' in Capacity input as P1T again same as P1I
                        CDF flight log data file by default is "cdf-flitelog".
                        CDF layout Parameters with optional new airfields and/or
                        Aircraft types is "cdf-conf.txt".
                        Required record types are '1', '2' in order, optionally type '3'
                        specifying the flight data file name otherwise it is the
                        default name, then record types '4' and/or '5', if required.
                        Pre-coded for a system param file called FLT-System-File
                        but not yet used. Could be for Users name and license number,
                        Date format information but there again can be found
                        via LC_TIME so using that for the moment.
                        CDF coding complete for rec types :
                          5 (aircraft).
                          4 (Airfield).
                          3 (CDF data file name).

                       Note that 'CSV' has replaced 'CDF'
                            (Comma Delimited File) throughout program including
                            these notes. CSV is the correct term even though CDF
                            explains it better.

                    .21 Bug fix for saving airfield table at end of Afld Edit.
                    .22 Forgot to make FLT narrative other than remarks upper-case.
                    .23 Created WS for captain substitute data but not coded YET.
                        Made F300, F400 thru exit and recoded if within if.
                    .24 added extra data for error FL045,48.
                    .25 Change unstring add from 2 to 1.
                    .26 CDF tests for ICAO-Code used FL045 should be FL023.

 02/11/18 vbc       .27 For CDF processing, write was in the perform & should
                        be just after it.
                    .28 Use end-if on test for .seq files. Now find the CDF date "
                    .29 issue in  F510-Read-CDF-File add 1 to A init 1 not 0.
                    .30 performing F100 dont go to f997 but f999.
                    .31 Start and end times and Pn stored wrong (as 0). Conversion bad ?
                        Error in using or not ws-cdf-time-n-format so using now
                        WS-CDF-Test-Time-Format having moved value from time-1 or time-2
                        depending on value of Z.
                    .32 Removed the temp displays after eval in convert time.
                    .33 missing end-if in proc for CDF MS so run thru most of the Zx00
                        coding. Hopefully fixes creating .SEQ files without requesting.
                    .34 F section not exiting correctly ie f500 to f999 & F00 to f997 or 8.
                    .35 Change EoT for CDF input display to use 21,22,23 lines.
                        Testing completed for all CDF input formats for Times as given
                        in var WS-CDF-Held-Time1 and Time2 as well as Dates as in
                        the first 7 formats in vars WS-CDF-Held-Date-Format
                        the Group defined as CDF-Sht-Date have NOT been tested as
                        these all use only YY with NO Century provided and as all
                        companies have converted their systems over from the Millenium
                        issues now use CC within the year values i.e., CCYY.
                    .36 Created CDF layout record 6 for captain search and replace
                        name - both are CASE SPECIFIC as program only does exact search
                        and replacement on data supplied 'AS IS'.
                        Next changes is multi format for the Date input routines to
                        support yyyy/mm/dd,  dd/mm/yyyy and mm/dd/yyyy and when done
                        version updated to v2.00.00. [TODO points 3 & 5.]
                        WS and procs added for multi date formats but will need changing.

 06/11/18 vbc - 2.00.00 All dates migrated over to using ws-test-intl and ws-test-date
                        and using zz050 and zz060 for conversion between the formats.
                        Lots of testing to check it all works as bound to have made
                        some mistakes. This removes TODO (5). All dates now support
                        UK, USA and Unix /Intl date formats for in/output and printing.

 07/11/18 vbc       .01 Support for Capacity of E1 (E2/3), R1 (R2/3) in addition to
                        P1,2,3 for Engineers and Radar operators (GIB) for military
                        flights. Some countries may use other designators in which
                        case users should request a feature fix.
                        This is for data entry and CDF.
                        Extra code for Save-Airfields to omit bad icao-code data.
                    .02 Must try and find out where it is happening!
                    .03 Reports date is still uk for USA - Nope is OK bad data
                        in test data definitions. Passes all 21 tests.

 08/11/18 vbc - 2.01.04 Updated CDF type 6 tests src-pos (6) in F500 with conv to UC.
                        More CDF def data testing.
                    .05 Forgot to add display FL011 to 'FLT-TO2'.
                    .06 In View aflds start on nonspace wrong should be not <'.
                    .07 Date not redisplayed after using ZZ060 for formatted (/).
                    .08 Added load params NONITE for no night time calcs and
                        NOSPOOL for no print report spooling (in *.nix).
                    .09 DISPLAY-FLAG test was before acft/afld loads - too much new
                        coding in the way - fixed moved slightly lower.
                    .10 Analysis display not clearing down screen after accept for new
                        data. Need extra screen width test chk for < 106 for Analysis
                        displays.
                    .11 Removed spool option looks bad - sticking to using Libreoffice
                        to format and print. Removed chaining P2 no longer needed.
                    .12 Support for the event of CDF file issuer using Capacilty of
                        PUT or P3 in CDF log book data but CDF file could come from a
                        flight training establishment.
                        Added on display after CDF file EOF, invalid writes to flightlog
                        - existing record count , ie., trying to create a duplicate record.
                    .13 Extra fields added to CDF defintition record 6 to support searching
                        for another CDF source field other than as defined as Captain for
                        when processing data for P2 or P3 pilots.

 18/11/18 vbc       .14 SY012 incorrectly shown as SY011. FL019 in use. Also accept
                        as parameter 1 (P1), NONITE which is the same as NONIGHT.
                        Also parameter 2 (P2) for a change in the name of the CDF
                        configuration file from the default of "cdf-conf.txt".
                        This is long enough to allow a path to be included (128 chars).

 20/11/18 vbc       .15 Added new field 2 to CDF layout rec 3 for data internal format
                        type, A or space for ASCII and E for EBCDIC if ever needed
                        moving old field 2 to 3. Prcessing for EBCDIC will involve a
                        routine processed after reading the CDF file converting each
                        character from a EBCDIC to ASCII before exiting routine so
                        that normal processing can continue. This using two tables.
                        swapped usage of FL006 for 017 in 1 instance as well as the pos
                        for return as wrong line used.
                    .16 Made new WS-DFT-BE fields to hold base values for display of aflds.
                        Updated them from accepted WS-Lines with rebased adjusted values.
                        Then using these instead of fixed numbers for -Length and -Cnt
                        in code. So now displaying Afields should make use of full length
                        of terminal screen. RETEST in menu 1 and 1 (enter/amend data).
                        Changed description in menu 1.C to be same as menu 2.U.
                    .17 Extra code start and test for CoE if data recs > date needed.
                        test done - good. Extra capacity groups added so now:
                        P, E, N, R, T. Should now cover all crew.
                    .18 Added FL049 & 50 from display info literals.

 22/11/18 vbc       .19 Removed usage of the E000 Aircraft fixup routine to rebuild the file
                        reading each flight log record.
                        Now it will update the aircraft file with the acft data and
                        update the internal table and sort it. This will save time
                        and more importantly retain the good acft data on file such
                        as the settings for Single acft Complex type which would
                        otherwise be lost.
                        Removed fixup option in menu 1 as no longer needed - I hope.
                        Leaving the code in for now - JIC.
                        In analysis create the file and table records for missing
                        Aircraft and Airfields. No should not happen but JIC if
                        user remove these files for any reason.
                        On logbk airfield capture, check for not alphabetc and re-accept.
                    .20 Moved menu 1 entries to menu 2 and making menu 2 the only menu.
                    .21 When producing CoE, check if Acft anal done and if not run
                        option E.
                    .22 Added test for "G" when doing same for "E" & "F" to stop rpt of
                        Airfields as only want acft for option G.
                    .23 Extra param P4 for ACFT-DATE to force Acft report in Flt Date order
                        descending.  Force CD reports for airfields to ignore unused ones,
                        i.e., not flown to or from. Just in case user loads up a full
                        Afld group for a country etc. Will not effect afld V or L options.

                        CCC030-LBR-HH-GET-REC  is WRONG as the acft sort is not and can not
                        sort the anal table as is.
                    .24 On init of afld and acft table setting key field to high-values to
                        make sure that sorts on key will place unused table entries beyond
                        the active table size.
                    .25 Added Help if param 1 = -h | -H | HELP | help | -?
                        Shows EBCDIC is not available as no one has requested it.
                        Removed E000-Fixup section coding as redundant moving some into
                        CCB020 (.19).
                    .26 Data entry Capacity omitted one type.
                        Slightly changed FL013 (near end).
                        Removed ZD000 code as no longer used (.19 & 25).
                        Added program name and version to the help screen.

 27/11/18 vbc -     .27 Backup files changed to Line sequential from just sequential to
                        minimise any possible issues with a new platform but may require
                        a text conversion between *nix based platforms and Windows.
                        For Aircraft allow for two new fields but currently marked out for
                             Aircraft-Man    pic x(20)
                             Aircraft-Name   pic x(20) both 20 characters long.
                        Print report PR4 allows, again remarked out.

 07/12/18 vbc -     .28 Changed CA235-Save to update dates for Airfield and Aircraft if
                        FLT-Date > stored date regardless od Entry or Amend mode.
                        extra comments in Remarks (above) regarding prtpdf and extra
                        packages required. Change goto  C000-EDIT-LOG-BOOK to a
                        perform with it returning to, then a900.

 10/12/18 vbc -     .29 Change spelling and case in main menu options.

 11/12/18 vbc -     .30 Change CSV code for instance of only processing type 4 & 5
                        records and if so CSV processing has finished correctly.
                        Code was not complying with manual.
                    .31 Extra coding for CSV without quotes around specific data
                        fields that adds one new field to type 1 rec. Bug #001
                        Bug #002 - non P1 crew cannot record capacity when importing
                        CSV data - To be fixed.
                        Change line-cnt-size-1 to 53 from 55 and
                               line-cnt-size-2 to 47 from 49.

 13/12/18 vbc -     .32 Change add to Line_Cnt specific at point of WRITE in CCA.

 14/12/18 vbc -     .33 Change end of F510 on CSV rec o/p on getting dup key
                        after the first one to display FL041 the next line '.'
                        for every dup rec, up to rec 106. This in case user has
                        re-input the same data.
                        Added on CSV rec type 6 new field 6 moving existing to Field 7
                        where new field is non P1 crew Capacity designation. For
                        companies that do not include it in data record.
                        Allow CSV data to contain no quotes between commas (F500).
                    .34 Forgot the code for New rec 6, Fld 6 but can it really be
                        one move just before writing the record out ?
                    .35 Created tables for converting EBCDIC to ASCII.
                        There is NO coding for processing this - subject to requests
                        but will need to use rec type 3 field 2 to specify the need to
                        do so as "E". See TODO (7).
                        Allow csv rec 2 fields 2 & 3 to also accept hh:mm.
                    .36 Extra tests in F501 for not using fields in quotes.
                    .37 Extra tests in ZL000-Create-Seq-Files for non zero status
                        on reads in case empty file.
                    .38 More chgs for csv data.
                    .39 CSV-TEST for P1 to display field values on CSV import.
                    .40 Removed very tmp test code but leaving the test (.39)
                        as useful if needing to test CSV config
                        Fault found on test for delimiter (quote or ') was 2 if's
                        should have been if else. Only showed up on last rec 1 type.

 18/12/18 vbc -     .41 Update to F520 to use quote an "'"
                    .42 Change in CCB020-Create-Airfield default name to
                        NAME MISSING to help make it stand out for any missing
                        Airfields.
                    .43 Was not testing CSV-Captain-Search against upper-case
                        captains name in CSV field.
                    .44 Changed program P2 parameter to start with 'CSV=' and sizes of
                        all P's to 64 chars. GC gets upset at 128.

 19/12/18 vbc - 2.02.00 Coding to change afld name from 20 - 36 chars.
                        Change Afld entry option K to support changed length.
                        Change Afld entry during Flight data entry/amend.

                        Tables for EBCDIC to ASCII updated for redefines.
                        Just need to add in the inspect, converting code during the read
                        of the data file. Now added - the problem will be to find
                        data to test it with. TODO (7) done.
                        Removed the airfield sort but kept the 'not print unused aflds'
                        facility. Sort by date just made it hard to read anyway.

 22/12/18 vbc - 2.02.01 Experiment for using airfield names in place of ICAO codes
                        PR11, PH11 ?     from TODO (2).
                        BUG - Using HIDDEN menu options 3 & 4 for C & D respectively.
                        Carried totals not happening chg test for > 1 instd of > 0
                        also BF totals need extra blank line after.
                        BUG - Loading airfields from file don't set last-flt so anal will
                        valid data if a flight was amended changing the Afld
                        BUG - In ZP000 on read invalid just goto reread table as any missing
                        result of a delete in option K.
                        Feature - Aircraft report for options C, D, 3 & 4. did not for C / 3.

 28/12/18 vbc - 2.02.02 Increased character set for converting between EBCDIC and ASCII
                        more special characters. Need to access MVS to test it.

 29/12/18 vbc       .03 CSV - Missed comma period in EBCDIC and ASCII tables.
                        EBCDIC tested using PDS VB .
                    .04 Problem with end of line that is not there so data
                        is one big block. This will not work less plan 2 can be
                        created and no, no idea at the moment.
                        AS this issue cannot be resolved when using a normal data
                        processing for ASCII data records as Line Sequential this
                        function is being removed (Data conversion EBCDIC to ACSII).
                        Method of storing original data on m/f can vary and process
                        to get around this problem will also vary so function removed.
                        Removed this from manual.
                        Likewise parameter P4 usage so now only 3 parameters maximum
                        used when starting program.

 02/01/19 vbc       .05 No data test if trying to run options that expect data to be present. FL016.
                        Silly omission but user could try it!
 07/09/19 vbc       .06 Added extra displays for fs-reply to see if start first is broken
                        with latest compiler code (v3.2 dev-0).

 12/09/19 vbc           Error in script comp-flightlog.sh as compiling program name mistyped.

 14/09/19 vbc       .07 Bug #5 fix for duplicate counting on airfield analysis
                        caused by fix for another bug or feature.
                         In CCB000-LBR-ANALYSIS changed if statements adding end-if's
                         to remove bug #005 duplicate adding airfield visit count.

 19/09/19 vbc       .08 Tail end of a previous printed flight Remarks then shows in next
                        line as overflow if sub totals when using options 3 & 4.

 19/11/19 vbc       .09 Minor typos both in manual and program.
                        In saving the sequential (text) files found some problems
                        using the latest version of the Cobol compiler i.e., v3.2,
                        including a bug that was missed.
                        The airfield display under Edit Airfield menu option K then V for
                        view was using three across but is wider than the maximum screen
                        size of 106 characters so reduced it to two across as left over
                        when screen size was 126 chars.
                        Missing display & accept in CE030-Proc-Acft-File when no rec found.

                    .10 CE030-Proc-Acft-File of at end or delete reload acft table.
                    .11 CSV record type 4 (Airfield) name increased to 32 characters to match
                        updated airfield file layouts. Any chars beyond will be ignored.

 22/08/21 vbc           Updated copyright to 2021.

 05/08/22 vbc       .12 Updated copyright to 2022, added support for running totals after
                        monthly totals by question for Options D, 4.

 18/08/22 vbc       .13 update making the latest release 2.02.13 along with updated manual
                        and other documentation.

 13/11/23 vbc       .14 Updated copyright to 2024, ok a bit early.
 23/09/25 vbc           Updated copyright to 2025. Ditto.
 17/01/26 vbc       .15 Updated copyright to 2026 and other minor notes.

